#include <stdio.h>
#include <signal.h>
#include <math.h>
#include <unistd.h>
#include <stdlib.h>
#include <sys/types.h> /* standard system data types. */
#include <sys/ipc.h> /* common system V IPC structures. */
#include <sys/msg.h> /* message-queue specific functions. */

typedef struct {
	long mtype;
	char mtext[70];
} MSGBUF;

float pi=0;
int msgid;

void Handler_Ch(int a)
{
	MSGBUF msg;
	signal(SIGUSR1, Handler_Ch);
	sprintf(msg.mtext, "%.67f", sqrt(pi));
	 // no flag set
        int rc = msgsnd(msgid, &msg, sizeof(msg.mtext), 0);
        if (rc == -1) {
                perror("child 1 msgsnd");
                exit(1);
        }	
}

void compute_pi2()
{
	float counter=1;
	signal(SIGINT, SIG_IGN);
	signal(SIGTSTP, SIG_IGN);
	signal(SIGUSR1, Handler_Ch);
	while(1)
	{
		pi = pi+(6/(counter*counter));
		counter++;
		sleep(1);
	}
}

int main()
{
	msgid = msgget(20, IPC_CREAT | 0400);
        if (msgid == -1) {
                perror("msgget in child 2 failed");
                exit(EXIT_FAILURE);
        }
	compute_pi2();
}
